=== debian/changelog ===
geos (3.14.1-1) unstable; urgency=medium

  * Update symbols for other architectures.
  * Move from experimental to unstable.

 -- Bas Couwenberg <sebastic@debian.org>  Wed, 29 Oct 2025 05:48:25 +0100

geos (3.14.1-1~exp1) experimental; urgency=medium

  * New upstream release.
  * Update lintian overrides.
  * Drop Rules-Requires-Root: no, default since dpkg 1.22.13.
  * Use test-build-validate-cleanup instead of test-build-twice.
  * Update symbols for amd64.

 -- Bas Couwenberg <sebastic@debian.org>  Mon, 27 Oct 2025 17:07:02 +0100
